#include "JIntStrArrayObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJIntStrArrayObj = JIntStrArrayObj().Register();


const char* JIntStrArrayObj::className() const { return "JIntStrArrayObj";}


JObject* JIntStrArrayObj::clone() const { return new JIntStrArrayObj(*this);}


// class constructor
JIntStrArrayObj::JIntStrArrayObj() {
  igm = 1;
  ogm = MAXOUT;
}


void JIntStrArrayObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("[D]"), rect);
}


boolean JIntStrArrayObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JIntStrArrayObj::inputTag(int n) {
  char* tag[] = {
    "inString" };
  return( tag[n] );
}


int JIntStrArrayObj::inputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JIntStrArrayObj::outputTag(int n) {
  char* tag[] = {
    "intVal_1",
    "intVal_2",
    "intVal_3",
    "intVal_4",
    "intVal_5",
    "intVal_6",
    "intVal_7",
    "intVal_8",
    "intVal_9",
    "intVal_10" };
  return( tag[n] );
}


JFRect JIntStrArrayObj::inputArea(int n) {
    return leftArea( n, 0, 1, 0.1, 0.8 );
}


JFRect JIntStrArrayObj::outputArea(int n) {
  return rightArea(n, 0, MAXOUT);
}


int JIntStrArrayObj::inputFace(int n) {
  if ( n < 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JIntStrArrayObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JIntStrArrayObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1, 0.1, 0.8);
}


JFPoint JIntStrArrayObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, MAXOUT);
}


void JIntStrArrayObj::access(int n, JLinkObj& link, const JDataType& data) {
    INT(data) = intVal[n];
}
#include <malloc.h>
#include <string.h>
#include <stdio.h>

char* newstrcpy( char* s ) {
	char* result = (char*)malloc( strlen(s) + 1 );
	strcpy( result, s );
	return( result );
}
void JIntStrArrayObj::processIntVal( char cval ) {
	if ( workingIntValOffset == -1 ) {
		workingIntValOffset = 0;
	}
	intValStr[ intValStrIdx++ ] = cval;
	intValStr[ intValStrIdx ] = 0;
}

#include <stdlib.h>
void JIntStrArrayObj::sendIntVal() {
	if ( intValStrIdx > 0 ) {
		if ( workingIntValOffset < MAXOUT ) {
			intVal[ workingIntValOffset ] = atoi( intValStr );
			broadcast( workingIntValOffset );
			workingIntValOffset++;
			intValStrIdx = 0;
		}
	}
}
	

void JIntStrArrayObj::processChar( char cval ) {
	if (( cval >= '0' ) && ( cval <= '9' )) {
		processIntVal( cval );
	} else {
		sendIntVal();
	}
}

void JIntStrArrayObj::engine(int n, JLinkObj& link) {
	int len = 0;
	int i = 0;
  switch (n) {
  case INSTRING:
    link.access( JStringData( inString ));
	len = inString.length();
	intValStrIdx = 0;
	workingIntValOffset = -1;
	for ( i = 0; i < len; i++ ) {
		processChar( inString[i] );
	}
	sendIntVal();
    break;
  default:
    break;
  }
}


