#if !defined( _JIntStrArrayObj_h )
#define _JIntStrArrayObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"


#define MAXOUT 10



class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JIntStrArrayObj : public JAddObj {
  protected:
  public:
    enum {
      INSTRING };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JIntStrArrayObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual int inputType( int n );
    virtual void access(int n, JLinkObj& link, const JDataType& data);
  private:
	  void processChar( char cval );
	  void processIntVal( char cval );
	  void sendIntVal();

	  char intValStr[40];
	  int intValStrIdx;

	  int workingIntValOffset;

    // inputs
    JString inString;

    // outputs
    int intVal[MAXOUT];
};


#endif
