#include "JWebInObj.h"

#include "JLinkObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JRealData.h"
#include "JBlockData.h"
#include "JBytesData.h"
#include "JCharacter.h"
#include "JStringData.h"
#include "JStringProperty.h"
#include "JIntegerProperty.h"
#include "JSocketException.h"
#include "JUnknownHostException.h"

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <time.h>
char* newstrcpy( char* x ) {
	char* xx = (char*)malloc( strlen( x ) + 1 );
	strcpy( xx, x );
	return( xx );
}


char* theJWebInObj = JWebInObj().Register();		  
void JWebInObj::writeContent(JOutputStream& os) {
  JAddObj::writeContent(os);
  putObject(os, "address", address);
  putInteger(os, "port", port);
  putObject(os, "url", url);
  putObject(os, "key1", key1);
  putInteger(os, "key1offset", key1offset);
  putObject(os, "key2", key2);
  putInteger(os, "key2offset", key2offset);
  putObject(os, "key3", key3);
  putInteger(os, "key3offset", key3offset);
  putObject(os, "key4", key4);
  putInteger(os, "key4offset", key4offset);
  putObject(os, "key5", key5);
  putInteger(os, "key5offset", key5offset);
  putObject(os, "key6", key6);
  putInteger(os, "key6offset", key6offset);
  putObject(os, "key7", key7);
  putInteger(os, "key7offset", key7offset);
  putObject(os, "key8", key8);
  putInteger(os, "key8offset", key8offset);
}
int JWebInObj::outputType( int n ) {
	if ( n < MaxValues ) {
		return( JIntegerData::id );
	} else if ( n < MaxValues * 2 ) {
		return( JRealData::id );
	} else {
		return( JStringData::id );
	}
}

void JWebInObj::readContent(JDictionary& dict) {
  JAddObj::readContent(dict);
  JObject *obj = getObject(dict, "address");
  if (obj) address = *(JString*)obj;
  port = getInteger(dict, "port");
  obj = getObject(dict, "url");
  if (obj) url = *(JString*)obj;
  obj = getObject(dict, "key1");
  if (obj) key1 = *(JString*)obj;
  key1offset = getInteger(dict, "key1offset");
  obj = getObject(dict, "key2");
  if (obj) key2 = *(JString*)obj;
  key2offset = getInteger(dict, "key2offset");
  obj = getObject(dict, "key3");
  if (obj) key3 = *(JString*)obj;
  key3offset = getInteger(dict, "key3offset");
  obj = getObject(dict, "key4");
  if (obj) key4 = *(JString*)obj;
  key4offset = getInteger(dict, "key4offset");
  obj = getObject(dict, "key5");
  if (obj) key5 = *(JString*)obj;
  key5offset = getInteger(dict, "key5offset");
  obj = getObject(dict, "key6");
  if (obj) key6 = *(JString*)obj;
  key6offset = getInteger(dict, "key6offset");
  obj = getObject(dict, "key7");
  if (obj) key7 = *(JString*)obj;
  key7offset = getInteger(dict, "key7offset");
  obj = getObject(dict, "key8");
  if (obj) key8 = *(JString*)obj;
  key8offset = getInteger(dict, "key8offset");
}

const char* JWebInObj::className() const { return "JWebInObj";}
JObject* JWebInObj::clone() const { 
    return new JWebInObj(*this);
}

JWebInObj::JWebInObj() {
  address = "localhost";
  url= "/";
  port = 80;
  connected = false;
  readInput = false;
  igm = 1;
  ogm = 30;
  xprocessResult = false;
  connecting = false;
  key1 = "(undefined)";
  key1offset = 0;
  key2 = "(undefined)";
  key2offset = 0;
  key3 = "(undefined)";
  key3offset = 0;
  key4 = "(undefined)";
  key4offset = 0;
  key5 = "(undefined)";
  key5offset = 0;
  key6 = "(undefined)";
  key6offset = 0;
  key7 = "(undefined)";
  key7offset = 0;
  key8 = "(undefined)";
  key8offset = 0;
  madeConnection = false;
}

JWebInObj::JWebInObj(const JWebInObj& obj) { *this=obj;}
JWebInObj::~JWebInObj() { close();}



void JWebInObj::reset() { 
  connected = false;
  data.Dereference();
  socket.close();
}

/**
 *  open
 *
 *  Purpose:
 *      Start a thread (if not already running) to connect to external program
 *      via sockets.
 */

void JWebInObj::open( JString openAddress, int openPort, JString openUrl ) {
	// if a previous thread hasn't used its connection args yet, wait
	while (connecting) {
		JThread::sleep(100);
	}
  cs.lock();
    currentAddress = openAddress;
    currentPort = openPort;
    currentUrl = openUrl;
	connecting = true;
    thread = JThread(this);
    thread.start();
    thread.setPriority(JThread::TNORM_PRIORITY+1);
  cs.unlock();
}


/**
 *  close
 *
 *  Purpose:
 *      Stop the thread (if not already stopped) that is connected to an
 *      external program via sockets.
 */

void JWebInObj::close() {
  cs.lock();
  if (connected) {
    connected = false;
    thread.setPriority(JThread::TNORM_PRIORITY);
    closeSocket(5);
    thread.waitFor();
    repaint();
  }
  cs.unlock();
}

void JWebInObj::openSocket() {
  boolean isIPAddr = true;
  for (int i=0; currentAddress[i]; i++) {
      if (JCharacter::isAlpha(currentAddress[i])) {
        isIPAddr = false;
	  }
  }
  if (isIPAddr) {
    JInetAddress inet = JInetAddress(JInetAddress::getAddrByJString(currentAddress));
    socket = JSocket(inet, currentPort);
  } else {
    JInetAddress inet = JInetAddress(address);
    socket = JSocket(inet, port);
  }
}
#include <winsock2.h>

boolean JWebInObj::connectSocket() {
  if (socket.connect()) {
    sis = JSocketInputStream(socket);
    sos = JSocketOutputStream(socket);
	int outFd = sos;
	char outBuf[500];
	sprintf( outBuf, "GET %s HTTP/1.0\r\n\r\n", (char*)currentUrl );
//Component::debug( newstrcpy( outBuf ));
	int result = send( outFd, outBuf, strlen( outBuf ), 0 );
	return true;
  }
  return false;
}

void JWebInObj::closeSocket(int count) {
  try {
    socket.close();
  } catch (JException *e) {
    delete e;
  }
}



/**
 *  Module characteristics associated with inputs.
 */

/**
 *  inputType
 *  
 *  Purpose:  
 *     get the input type corresponding to location
 *     All input types are int
 */

int JWebInObj::inputType(int n) { 
    return JIntegerData::id;
}


/**
 *  inputTag
 *
 *  Purpose:
 *     provide a JString describing an input.
 */

JString JWebInObj::inputTag(int n) {
  char* tag[] = {

      // top inputs
        "readInput",  
  };
  return( tag[n] );
 }



boolean JWebInObj::inputAllowed(int n) { 
        return !inputSet(n).last();
}


JFRect JWebInObj::inputArea(int n) {
  return topArea( n, 0, 1, 0.25 );
}


JFRect JWebInObj::outputArea(int n) {
  return rightArea(n, 0, MaxValues*3, 0.1);
}


int JWebInObj::inputFace(int n) {
  return TOP;
}




JFPoint JWebInObj::inputPoint(int n, JLinkObj& link) {
  return topPoint(n, link, 0, 1 );
}


JFPoint JWebInObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, MaxValues*3, 0.1);
}

/**
 *  Module characteristics associated with outputs
 */



void JWebInObj::paint(JGraphics g, double dx, double dy, JRegion& rgn, double scale) {
  JAddObj::paint(g, dx, dy, rgn, scale);
  JRect rect = getIExtent(dx, dy, scale);
  int kw = depth2*3;
  if ((rect.width > kw) && (rect.height > kw)) {
    if (madeConnection) g.setJColor(JColor::green);
    else g.setJColor(JColor::red);
    g.fillRect(rect.x+depth2, rect.y+depth2, depth2, depth2);
  }
}

void JWebInObj::draw(JGraphics g, int x, int y, int w, int h) {
  int dh = h/3;
  int dy = h/12;
  JRect rect1(x, y+dy, w, dh);
  JRect rect2(x, y+h/2, w, dh);
  drawText(g, "WEBIN", rect1);
  drawText(g, address+":"+JInteger::toJString(port), rect2);
}




/**
 *  engine
 *
 *  Purpose:
 *     The main processing engine for this module, called whenever
 *     data is received on an incoming visual link.
 */
void JWebInObj::engine(int n, JLinkObj& link) {
    switch (n) {
    case READINPUT:
        link.access(JIntegerData(readInput));
        if (readInput && !connected) {
			xprocessResult = true;
			open(address, port, url);
		} else if (!readInput && connected && wroteData) {
			close();
		}
        break;
    default:
        break;
    }
}


JArray JWebInObj::getProperties() {
  JArray properties = JAddObj::getProperties();
  properties.append(JStringProperty("hostName/IPaddress", address));
  properties.append(JIntegerProperty("port", port, 80, 10000));
  properties.append(JStringProperty("url", url));
  properties.append(JStringProperty("key1",key1));
  properties.append(JIntegerProperty("key1offset", key1offset, -50, 50 ));
  properties.append(JStringProperty("key2",key2));
  properties.append(JIntegerProperty("key2offset", key2offset, -50, 50 ));
  properties.append(JStringProperty("key3",key3));
  properties.append(JIntegerProperty("key3offset", key3offset, -50, 50 ));
  properties.append(JStringProperty("key4",key4));
  properties.append(JIntegerProperty("key4offset", key4offset, -50, 50 ));
  properties.append(JStringProperty("key5",key5));
  properties.append(JIntegerProperty("key5offset", key5offset, -50, 50 ));
  properties.append(JStringProperty("key6",key6));
  properties.append(JIntegerProperty("key6offset", key6offset, -50, 50 ));
  properties.append(JStringProperty("key7",key7));
  properties.append(JIntegerProperty("key7offset", key7offset, -50, 50 ));
  properties.append(JStringProperty("key8",key8));
  properties.append(JIntegerProperty("key8offset", key8offset, -50, 50 ));
  return properties;
}

boolean JWebInObj::updateProperty(JProperty& prop) {
  if (JAddObj::updateProperty(prop)) return true;
  boolean changed = false;
  if (prop.getName() == JString("port")) {
    port = ((JIntegerProperty*)&prop)->value;
    changed = true;
  } else if (prop.getName() == JString("hostName/IPaddress")) {
    address = ((JStringProperty*)&prop)->value;
    changed = true;
  } else if (prop.getName() == JString("url")) {
    url = ((JStringProperty*)&prop)->value;
    changed = true;
  } else if (prop.getName() == JString("key1")) {
	  key1 = ((JStringProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key1offset")) {
	  key1offset = ((JIntegerProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key2")) {
	  key2 = ((JStringProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key2offset")) {
	  key2offset = ((JIntegerProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key3")) {
	  key3 = ((JStringProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key3offset")) {
	  key3offset = ((JIntegerProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key4")) {
	  key4 = ((JStringProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key4offset")) {
	  key4offset = ((JIntegerProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key5")) {
	  key5 = ((JStringProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key5offset")) {
	  key5offset = ((JIntegerProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key6")) {
	  key6 = ((JStringProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key6offset")) {
	  key6offset = ((JIntegerProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key7")) {
	  key7 = ((JStringProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key7offset")) {
	  key7offset = ((JIntegerProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key8")) {
	  key8 = ((JStringProperty*)&prop)->value;
	  changed = true;
  } else if (prop.getName() == JString("key8offset")) {
	  key8offset = ((JIntegerProperty*)&prop)->value;
	  changed = true;
  }
  if (changed) repaint();
  return changed;
}


void JWebInObj::initData() {
	foundBody = false;
	body1 = "<body";
	bodyScanner1 = body1;
	body2 = "<BODY";
	bodyScanner2 = body2;
	outIdx = 0;
	workingOnValue = false;
	wroteData = false;
	key1len = key1.length();
	key2len = key2.length();
	key3len = key3.length();
	key4len = key4.length();
	key5len = key5.length();
	key6len = key6.length();
	key7len = key7.length();
	key8len = key8.length();
}


bool JWebInObj::processData( char* b, int size ) {
	char* keys[] = { key1, key2, key3, key4, key5, key6, key7, key8 };
	int offsets[] = { key1offset, key2offset, key3offset, key4offset, key5offset, key6offset, key7offset, key8offset };
	static char* results[] = { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL };
	bool retval = false;
	//JComponent::debug( "processData" );
	//JComponent::debug( newstrcpy( b ));
	for ( int i = 0; i < 8; i++ ) {
		char* result = strstr( b, keys[i] );
		int keylen = strlen( keys[i] );
		int keyoffset = offsets[i];
		if ( result != NULL ) {
			retval = true;
			if ( keys[i][0] == '<' ) {
				if ( results[i] != NULL ) {
					free( results[i] );
				}
				results[i] = newstrcpy( processXresult( b, size, ( result - b + keylen )));
				xvalue[i] = JString( results[i] );
				broadcast( MaxValues * 2 + i );
			} else {
				mvalue[i] = processResult( b, size, result - b + keyoffset );
				if ( mvalue[i] != -1 ) {
					broadcast( i );
				} 
				fvalue[i] = processFresult( b, size, result - b + keyoffset );
				if ( fvalue[i] != -1.0f ) {
					broadcast( MaxValues + i );
				}
			}
		}
	}
	return( retval );
}



//
// character by character matching, returns -1 if string matches, if char matches,
// returns next offset, if char does not match, returns 0, if offset is -1 (indicating
// it already matched, returns 0)
//

int JWebInObj::processKey( char x, JString& s, int offset, int keylen ) {
	if (( offset != -1 ) && ( offset < keylen )) {
		if ( s[ offset ] == x ) {
			offset++;
			if ( offset == keylen ) {
				return( -1 );
			} else {
				return( offset );
			}
		}
	}
	return( 0 );
}


int JWebInObj::processResult( char* b, int size, int start ) {
	int result = 0;
	for ( int i = start; i < size; i++ ) {
		if (( b[ i ] >= '0' ) && ( b[ i ] <= '9' )) {
			result = result * 10 + ( b[i] - '0' );
		} else {
			return result;
		}
	}
	return -1;
}

char* JWebInObj::processXresult( char* b, int size, int start ) {
	char xbuf[300];
	int scanner = 0;
	xbuf[0] = 0;

	for ( int i = start; i < size; i++ ) {
		if ( b[i] == '<' ) {
			return( &xbuf[0] );
		} else {
			xbuf[ scanner++ ] = b[i];
			xbuf[ scanner ] = 0;
		}
	}
	return( &xbuf[0] );
}

float JWebInObj::processFresult( char* b, int size, int start ) {
	float result = -1.0f;
	int left = 0;
	int right = 0;
	bool foundSomething = false;
	for ( int i = start; i < size; i++ ) {
		if (( b[ i ] >= '0' ) && ( b[ i ] <= '9' )) {
			left = left * 10 + ( b[i] - '0' );
			foundSomething = true;
		} else {
			i++;
			break;
		}
	}
	int rightFactor = 1;
	for ( ; i < size; i++ ) {
		if (( b[ i ] >= '0' ) && ( b[ i ] <= '9' )) {
			right = right * 10 + ( b[i] - '0' );
			foundSomething = true;
			rightFactor = rightFactor * 10;
		} else {
			break;
		}
	}
	if ( foundSomething ) {
		result = (float)left + (float)right/(float)rightFactor;
	}

	return result;
}

JString JWebInObj::outputTag(int n) {
  char* tag[] = {
    "int_1",
    "int_2",
    "int_3",
    "int_4",
    "int_5",
    "int_6",
    "int_7",
    "int_8",
    "int_9",
    "int_10",
    "float_1",
    "float_2",
    "float_3",
    "float_4",
    "float_5",
    "float_6",
    "float_7",
    "float_8",
    "float_9",
    "float_10",
	"xml_1",
	"xml_2",
	"xml_3",
	"xml_4",
	"xml_5",
	"xml_6",
	"xml_7",
	"xml_8",
	"xml_9",
	"xml_10"
  };
  return( tag[n] );
}



void JWebInObj::writeData() {
	wroteData = true;
	for ( int i = 0; i < outIdx; i++ ) {
		broadcast( i );
	}
}

void JWebInObj::access(int n, JLinkObj& link, const JDataType& data) { 
	if ( n < MaxValues ) {
     INT(data) = mvalue[n];
	} else if ( n < MaxValues*2 ) {
		DOUBLE(data) = (double)fvalue[n-MaxValues];
	} else {
		JSTRING(data) = xvalue[n-MaxValues*2];
	}
}

/**
 *  processInputStream
 *
 *  Purpose:
 */
static int counter = 0;
static char dataBuf[5000];

void JWebInObj::processInputStream() {
    JBlock inputData(50, 0);
	initData();
	counter = 0;
	dataBuf[0] = 0;
  while (connected > true) {
    try {
	  int socketHandle = sos;
	  counter++;
	  if ( counter == 400 ) {
		  exit( 0 );
	  }
	  char buf[10000];
	  int result = recv( socketHandle, &buf[0], 10000, 0 );
	  if ( result > 0 ) {
		buf[result] = 0;
		//omponent::debug( newstrcpy( &buf[0] ));
		madeConnection = true;
		if (( strlen( dataBuf ) + result ) < 5000 ) {
			strcat( dataBuf, buf );
		}
		/*
		  if ( processData( &buf[0], result ))
		  //if ( counter > 1 )
		return;
		*/
	  } else if ( result == -1 ) {
		  processData( &dataBuf[0], strlen( dataBuf ));
		  return;
	  } else if ( result == 0 ) {
		  //omponent::debug( "z result" );
		  //unter++;
		  if ( counter == 20) {
			  processData( &dataBuf[0], strlen( dataBuf ));
			  return;
		  }
	  }
    } catch (JException *e) {
        JComponent::debug( "input stream thread got exception" );
		writeData();
	 
      delete e;
      return;
    }
  }
}


void JWebInObj::run() {
	initData();
	try {
		openSocket();
	} catch (JException *e) {
		JComponent::debug( "got exception" );
		JComponent::debug( e->getMessage() );
		delete e;
		closeSocket(1);
		connecting = false;
		return;
	}
	connected = true;
	repaint();
	try {
		while (connected) {
			if (connectSocket()) break;
			JThread::sleep(100);
		}
		connecting = false;
		if (!connected) {
			closeSocket(2);
			connected = false;
			repaint();
			return;
		}
	} catch (JException *e) {
		delete e;
		closeSocket(3);
		repaint();
		return;
	}
	connected++;
	madeConnection = true;
	repaint();
	if ( xprocessResult ) {
		processInputStream();
	}
	if (connected > true) {
		closeSocket(4);
	}
	repaint();
	connected = false;
}

