#if !defined( _JWebInObj_h )
#define _JWebInObj_h

#include "JAddObj.h"
#include "JSocket.h"
#include "JSocketInputStream.h"
#include "JSocketOutputStream.h"
#include "JThread.h"
#include "JCriticalSection.h"

#define MaxValues 10

class JWebInObj : public JAddObj {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    enum {
      READINPUT, SENDOUTPUT };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JWebInObj();
    JWebInObj(const JWebInObj& obj);
    virtual ~JWebInObj();
    virtual void reset();
    virtual void open( JString openAddress, int openPort, JString openUrl );
    virtual void close();
    virtual void openSocket();
    virtual boolean connectSocket();
    virtual void closeSocket(int n);
    virtual int inputType(int n);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
	virtual int outputType(int n);
    virtual int inputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void paint(JGraphics g, double dx, double dy, JRegion& rgn, double scale);
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual void engine(int n, JLinkObj& link);
    virtual void run();
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    virtual void access(int n, JLinkObj& link, const JDataType& data);
    void processInputStream();
  protected:
	  void initData();
	  bool processData( char* b, int size );
	  int processResult( char* b, int size, int start );
	  float processFresult( char* b, int size, int start );
	  char* processXresult( char* b, int size, int start );
	int processKey( char x, JString& s, int offset, int keylen );
	int tempVal;

	void writeData();
	bool madeConnection;
    JSocket socket;
    JSocketInputStream sis;
    JSocketOutputStream sos;

    boolean connected;
	boolean wroteData;
    JThread thread;
    JArray data;
    JCriticalSection cs;
	int foundBody;
	char* body1;
	char* bodyScanner1;
	char* body2;
	char* bodyScanner2;
	int outIdx;
	int workingOnValue;

    // controls
    int readInput;
	int sendOutput;

    // properties
    JString address;
    int port;
    JString url;

	JString key1;
	int key1offset;
	JString key2;
	int key2offset;
	JString key3;
	int key3offset;
	JString key4;
	int key4offset;
	JString key5;
	int key5offset;
	JString key6;
	int key6offset;
	JString key7;
	int key7offset;
	JString key8;
	int key8offset;

	int key1len;
	int key2len;
	int key3len;
	int key4len;
	int key5len;
	int key6len;
	int key7len;
	int key8len;

	// since we can open one or other, need to track current
	boolean connecting;   // delays thread until other requests are finished...
	JString currentAddress;
	int currentPort;
	JString currentUrl;
	boolean xprocessResult;

    // outputs
    int mvalue[MaxValues];
	float fvalue[MaxValues];
	JString xvalue[MaxValues];
};

#endif
